Description

In the documentation (https://docs.ruby-lang.org/en/3.4/encodings_rdoc.html#label-String+Encoding) | see a good explanation of
default string encodings:

String Encoding

A Ruby string object has an encoding that is an instance of class Encoding. The encoding
may be retrieved by method String#encoding .

The default encoding for a string literal is the script encoding; see Script Encoding.

's'.encoding # => #<Encoding:UTF-8>

The default encoding for a string created with method String.new is:

¢ For a String object argument, the encoding of that string.

¢ For a string literal, the script encoding; see Script Encoding.

However, it does not mention String.new without an argument, which is the one case where | see inconsistent behavior.

irb(main) : 001> "".encoding

=> #<Encoding:UTF-8>

irb(main) : 002> String.new("") .encoding
=> #<Encoding:UTF-8>

irb(main) : 003> String.new(a="") .encoding
=> #<Encoding:UTF-8>

irb(main) : 004> String.new.encoding

=> #<Encoding:BINARY (ASCII-8BIT)>

Should this be documented or changed?

Associated revisions

Revision cde065c32c8db34eaf2c6b8646a2d4a34e20a3ec - 01/10/2025 10:36 PM - deivid (David Rodriguez)

Clarify documentation for encoding of String.new without arguments

[Bug #21025]

Revision cde065c32c8db34eaf2c6b8646a2d4a34e20a3ec - 01/10/2025 10:36 PM - deivid (David Rodriguez)
Clarify documentation for encoding of String.new without arguments

[Bug #21025]

Revision cde065c3 - 01/10/2025 10:36 PM - deivid (David Rodriguez)

Clarify documentation for encoding of String.new without arguments

[Bug #21025]

06/29/2025 12



https://docs.ruby-lang.org/en/3.4/encodings_rdoc.html#label-String+Encoding

History

#1 - 01/10/2025 05:22 PM - Eregon (Benoit Daloze)

It's just a documentation bug.
It's always BINARY for String.new without args.

#2 - 01/10/2025 06:12 PM - deivid (David Rodriguez)

Cool, thanks for the info, I'll create a PR to improve the documentation.

#3 - 01/10/2025 07:48 PM - deivid (David Rodriguez)
| created https://github.com/ruby/ruby/pull/12548 for this.

#4 - 01/10/2025 11:03 PM - deivid (David Rodriguez)
- Status changed from Open to Closed

Applied in changeset git|cde065c¢32c8db34eaf2c6b8646a2d4a34e20a3ec.
